﻿using HarmonyLib;
using UnityEngine;

public class ConfigurableDamage : Mod
{
    private static ConfigurableDamage instance;
    private const string id = "cmd430.ConfigurableDamage";
    private Harmony harmony = null;
    private float playerDamageMulti = 2;

    // Setup
    public void Start()
    {
        instance = this;
        (harmony = new Harmony(id)).PatchAll(System.Reflection.Assembly.GetExecutingAssembly());
        Debug.Log("[ConfigurableDamage] has been loaded!");
    }
    public void OnModUnload()
    {
        harmony.UnpatchAll(id);
        Debug.Log("[ConfigurableDamage] has been unloaded!");
    }
    public void ExtraSettingsAPI_Load()
    {
        if (ExtraSettingsAPI_Loaded) instance.playerDamageMulti = ExtraSettingsAPI_GetSliderRealValue("playerDamageMulti");
    }
    public void ExtraSettingsAPI_SettingsClose()
    {
        if (ExtraSettingsAPI_Loaded) instance.playerDamageMulti = ExtraSettingsAPI_GetSliderRealValue("playerDamageMulti");
    }

    // Patch
    [HarmonyPatch(typeof(Network_Host), "DamageEntity")]
    public static class Network_Host_DamageEntity_Patch
    {
        private static void Prefix(ref Network_Entity entity, ref float damage, ref EntityType damageInflictorEntityType)
        {
            if (entity.entityType == EntityType.Enemy && damageInflictorEntityType == EntityType.Player)
            {
                damage *= instance.playerDamageMulti;
            }
        }
    }

    // ExtraSettingsAPI
    static Traverse ExtraSettingsAPI_Traverse;
    static bool ExtraSettingsAPI_Loaded = false;
    public float ExtraSettingsAPI_GetSliderRealValue(string SettingName)
    {
        if (ExtraSettingsAPI_Loaded)
            return ExtraSettingsAPI_Traverse.Method("getSliderRealValue", new object[] { this, SettingName }).GetValue<float>();
        return 0;
    }
}